package com.jsonpfy.webservices;

import java.io.IOException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.jsonpfy.operations.SaveData;
import com.jsonpfy.utilities.CallbackUtilities;
import com.jsonpfy.utilities.JsonpfyProperties;
import com.jsonpfy.utilities.URLUtilities;

@SuppressWarnings("serial")
public class SaveDataServlet extends HttpServlet {

	// http://localhost:8888/SaveDataService?
	// kind=Comment
	// &fieldsKind=String&fieldsName=description&fieldsValue=Test 2
	// &fieldsKind=String&fieldsName=projectID&fieldsValue=Projectnection
	// &fieldsKind=String&fieldsName=classPath&fieldsValue=com.projectnection.client.Entities.EntityPage
	// &fieldsKind=String&fieldsName=username&fieldsValue=Alline Watkins
	// &fieldsKind=String&fieldsName=email&fieldsValue=alline.oliveira@gmail.com
	// &fieldsKind=String&fieldsName=facebookUserID&fieldsValue=alline.oliveira
	// &fieldsKind=Date&fieldsName=date&fieldsValue=1313085767484

	public void doGet(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

		if (JsonpfyProperties.OPEN) {

		//	response.addHeader("Access-Control-Allow-Origin", "*");
		//	response.setContentType("text/plain");
		//	response.setCharacterEncoding("UTF-8");
			
		/*	[Pragma : no-cache, 
			 Last-Modified : 2012-10-09T23:20:48+0000, 
			 Content-Type : text/javascript; charset=UTF-8,
			 Cache-Control : private, no-cache, no-store, must-revalidate, 
			 Expires : Sat, 01 Jan 2000 00:00:00 GMT] */
			
			response.getWriter().println(saveData(request));

		}
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response)
			throws IOException {

	//	response.addHeader("Access-Control-Allow-Origin", "*");
	//	response.setContentType("text/plain");
	//	response.setCharacterEncoding("UTF-8");
		response.getWriter().println(saveData(request));

	}

	private String saveData(HttpServletRequest request) {

		String answer = null;

		if (JsonpfyProperties.OPEN || JsonpfyProperties.authenticate(request)) {

			String kind = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_KIND));

			String ID = URLUtilities.decode(request
					.getParameter(JsonpfyProperties.ENTITY_ID));

			String override = URLUtilities.decode(request
					.getParameter("override"));

			String[] fieldsKind = request.getParameterValues("fieldsKind");

			String[] fieldsName = request.getParameterValues("fieldsName");

			String[] fieldsValue = request.getParameterValues("fieldsValue");

			String id = SaveData.doPut(kind, ID, fieldsKind, fieldsName,
					fieldsValue, override);

			answer = CallbackUtilities.getCallback(
					request.getParameter("callback"), id);
		}
		return answer;
	}
}
