package com.jsonpfy.operations;

import java.util.ArrayList;

import org.json.JSONArray;

import com.google.appengine.api.datastore.Entity;
import com.google.appengine.api.datastore.Key;
import com.jsonpfy.utilities.ConvertEntityToJson;

/**
 * List the data of a particular sublist of a kind field in the datastore.
 * 
 * @Feature
 */
public class ListSubArray {

	public static JSONArray jsonList(String kind, String ID,
			String fieldSubArray) {

		JSONArray jsonArray = new JSONArray();

		Entity entity = GetData.getEntity(kind, ID);

		ArrayList<Key> subArray = (ArrayList<Key>) entity
				.getProperty(fieldSubArray);

		for (Key subID : subArray) {

			Entity subEntity = GetData.getEntity(subID);

			jsonArray.put(ConvertEntityToJson.getJson(subEntity, null));
		}

		return jsonArray;
	}

}